<?php
/*
 * ==========================================================
 * BOXCOIN WHMCS MODULE
 * ==========================================================
 *
 *  2022 Boxcoin. All rights reserved.
 *
 */

if (!defined('WHMCS')) {
    die('This file cannot be accessed directly');
}

function boxcoin_MetaData() {
    return array(
        'DisplayName' => 'Boxcoin',
        'APIVersion' => '1.2',
        'DisableLocalCreditCardInput' => true,
        'TokenisedStorage' => false,
    );
}

function boxcoin_config() {
    global $CONFIG;
    return array(
        'FriendlyName' => array(
            'Type' => 'System',
            'Value' => 'Boxcoin',
        ),
        'boxcoinURL' => array(
            'FriendlyName' => 'Boxcoin URL',
            'Type' => 'text',
            'Size' => '25',
            'Default' => '',
            'Description' => 'Enter the URL of your Boxcoin admin area, e.g. https://www.example.com/boxcoin/admin.php.',
        ),
        'boxcoinKey' => array(
            'FriendlyName' => 'Webhook secret key',
            'Type' => 'password',
            'Size' => '25',
            'Default' => '',
            'Description' => 'Enter the Boxcoin webhook secret key. Get it from Boxcoin > Settings > Webhook > Webhook secret key.',
        ),
        'cloudKey' => array(
            'FriendlyName' => 'Cloud API key',
            'Type' => 'text',
            'Size' => '25',
            'Default' => '',
            'Description' => 'If you are using the cloud version, enter the Boxcoin API key. Get it from Boxcoin > Account > API key.',
        ),
        'webhookURL' => array(
            'FriendlyName' => 'Webhook URL',
            'Type' => 'text',
            'Size' => '25',
            'Value' => $CONFIG['SystemURL'] . '/modules/gateways/callback/boxcoin.php',
            'Default' => $CONFIG['SystemURL'] . '/modules/gateways/callback/boxcoin.php'
        )
    );
}

function boxcoin_link($params) {
    $encrypted = localAPI('EncryptPassword', array('password2' => strval($params['invoiceid'])));
    $link = str_replace(['admin.php', '//pay.php'], ['', '/pay.php'], $params['boxcoinURL'] . '/pay.php?checkout_id=custom-whmcs&price=' . $params['amount'] . '&currency=' . $params['currency'] . '&external-reference=' . base64_encode(is_string($encrypted) ? $encrypted : $encrypted['password']) . '&redirect=' . urlencode($params['returnurl']) . (trim($params['cloudKey']) ? '&cloud=' . trim($params['cloudKey']) : '') . '&note=' . urlencode('WHMCS invoice ID ' . $params['invoiceid']));
    return strpos($_SERVER['REQUEST_URI'], 'viewinvoice') ? '<a href="' . $link . '" class="btn btn-success btn-sm" id="boxcoin-link">' . (!isset($_LANG) || empty($_LANG['PAY_NOW']) ? 'Pay now' : $_LANG['PAY_NOW']) . '</a>' : '<script>document.location = "' . $link . '";</script>';
}